Consumer Producer demo app
==========================

INTRODUCTION
------------
This demo is going to demonstrate the use of consumer source and producer operation of Mule Apache Kafka Connector. It consists of below flows:

* **ui-provider-flow** - This flow is responsible with providing a nice web page when the user is hitting "localhost:8081" from their favorite browser.
* **consumer-flow** - This flow is responsible with logging messages read from a Kafka topic through "Consumer" source provided by connector. It is logging the messages on Studio's console with the following format **"New message arrived: \<message\>"**
* **producer-flow** - This flow is responsible with sending a message to a Kafka topic through "Producer" operation provided by connector. It is exposing an http endpoint that the user can invoke with topic to which the message is sent and the message to be sent.

HOW TO RUN DEMO
---------------

### Prerequisites
In order to build and run this demo project you'll need:

* Anypoint Studio with at least Mule ESB 3.7 Runtime.
* Mule Apache Kafka Connector v1.0.0.
* An instance of Kafka server up and running with a topic already created. For more information on how to configure Kafka server see [Apache Kafka documentation](http://kafka.apache.org/documentation.html)

### Test the flows

Import the demo project into your workspace via "Anypoint Exchange" or "Import..." from "File" menu.

From the Package Explorer view, expand the demo project and open the **mule-app.properties** file. Fill in the values for properties as explained below:

* **config.bootstrapServers** - this is comma separated values of initial list of your Kafka nodes and is the same with **bootstrat.servers** from Kafka's documentation.
* **config.consumerPropertiesFile** - relative path to **src/main/resources** of a java properties file containing consumer specific properties and is the same file that you would provide to **kafka-console-consumer** command line tool that comes with Kafka server. It can be left empty if default properties are enough.
* **config.producerPropertiesFile** - relative path to **src/main/resources** of a java properties file containing producer specific properties and is the same file that you would provide to **kafka-console-producer** command line tool that comes with Kafka server. It can be left empty if default properties are enough.
* **consumer.topic** - the topic name of your Kafka topic that the mule consumer will use for polling messages from.
* **consumer.topic.partitions** - the number of partitions that you have set on your Kafka topic at creation.

Run the demo project and from within your favorite browser hit - **http://localhost:8081/**. A web form will be displayed. Fill **"Topic"** with topic name of your Kafka topic (eventually the one that you provided for **consumer.topic** above), change the default value for **"Message"** if you want and hit **Push Message**. Now the message will be pushed to your topic and if you published the message to the same topic that you set for **consumer.topic** config then you should see it logged within studio's console by **consumer-flow**.

SUMMARY
-------

Congratulations! You have produced and consumed messages from your Kafka server through the connector.
